package de.unima.ki.pi2.ptest.aufgabe1.test;

import static org.junit.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

import de.unima.ki.pi2.ptest.aufgabe1.api.LogicEvenOrOdd;
import de.unima.ki.pi2.ptest.aufgabe1.impl.LogicEvenOrOddImpl;

public class LogicEvenOrOddTest {
	
	
	private LogicEvenOrOdd logic;
	
	@Before
	public void init(){ 
		this.logic = new LogicEvenOrOddImpl();
	}

	@Test
	public void test0() {
		boolean[] x = new boolean[]{};
		assertEquals(true, this.logic.isEven(x));
		assertEquals(false, this.logic.isOdd(x));
	}
	
	@Test
	public void test1a() {
		boolean[] x = new boolean[]{true};
		assertEquals(false, this.logic.isEven(x));
		assertEquals(true, this.logic.isOdd(x));
	}
	
	@Test
	public void test1b() {
		boolean[] x = new boolean[]{false};
		assertEquals(true, this.logic.isEven(x));
		assertEquals(false, this.logic.isOdd(x));
	}
	
	@Test
	public void test3a() {
		boolean[] x = new boolean[]{true, true, true};
		assertEquals(false, this.logic.isEven(x));
		assertEquals(true, this.logic.isOdd(x));
	}
	
	@Test
	public void test3b() {
		boolean[] x = new boolean[]{false, false, false};
		assertEquals(true, this.logic.isEven(x));
		assertEquals(false, this.logic.isOdd(x));
	}
	
	@Test
	public void test7even() {
		boolean[] x = new boolean[]{false, false, true, true, false, false, true};
		assertEquals(false, this.logic.isEven(x));
	}
	
	
	@Test
	public void test7odd() {
		boolean[] x = new boolean[]{false, false, true, true, false, false, true};
		assertEquals(true, this.logic.isOdd(x));
	}
	
	@Test
	public void test10() {
		boolean[] x = new boolean[]{true, false, true, true, false, false, true, true, false, true};
		assertEquals(true, this.logic.isEven(x));
		assertEquals(false, this.logic.isOdd(x));
	}
	
	@Test
	public void test101() {
		boolean[] x = new boolean[101];
		for (int i = 0; i < 101; i++) {
			x[i] = ((i % 3 == 0) ? true : false);			
		}
		assertEquals(true, this.logic.isEven(x));
		assertEquals(false, this.logic.isOdd(x));
	}
	
	@Test
	public void test1003() {
		boolean[] x = new boolean[1003];
		for (int i = 0; i < 1003; i++) {
			x[i] = ((i % 3 == 0) ? true : false);			
		}
		assertEquals(false, this.logic.isEven(x));
		assertEquals(true, this.logic.isOdd(x));
	}
	
}
