package de.unima.ki.pi2.ptest.aufgabe2.impl;

import java.util.HashMap;

import de.unima.ki.pi2.ptest.aufgabe2.api.CharCounterX;

public class CharCounterXImpl implements CharCounterX {

	private HashMap<Character, Integer> counter;
	
	public CharCounterXImpl() {
		this.counter = new HashMap<Character, Integer>();
	}
	
	public void parse(String text) {
		this.counter.clear();
		char[] cText = text.toCharArray();
		for (char c : cText) {
			if (this.counter.containsKey(c)) {
				this.counter.put(c, this.counter.get(c) + 1);
			}
			else {
				this.counter.put(c, 1);
			}
		}
	}

	public int getNumOfChars(char c) {	
		if (this.counter.containsKey(c)) {
			return this.counter.get(c);
		}
		else {
			return 0;
		}
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer("");
		if (this.counter.size() > 0) {
			for (char c : this.counter.keySet()) {
				sb.append(c + ": " + this.counter.get(c) + "\n");
			}
		}
		else {
			sb.append("... nothing counted");
		}
		return sb.toString();
	}


	public char[] getRareChars() {
		// ...
		
		return new char[]{0,0};
	}
	
	public static void main(String[] args) {
		CharCounterX cx = new CharCounterXImpl();
		cx.parse("aaabbccd");
		System.out.println(cx.toString());
		char[] rare = cx.getRareChars();
		System.out.println("Seltenster Buchstabe: " + rare[0]);
		System.out.println("Zweitseltenster Buchstabe: " + rare[1]);
	}	

}
