package de.unima.ki.pi2.ptest.aufgabe3.test;

import static org.junit.Assert.assertEquals;
import java.util.ArrayList;


import org.junit.Test;

import de.unima.ki.pi2.ptest.aufgabe3.impl.ProcessCheckerImpl;


public class ProcessCheckerTest {
		
	@Test
	public void testExecutable1() {
		int[] curAvailRes = {3,3,2};
		ProcessCheckerImpl pc = new ProcessCheckerImpl(curAvailRes);
		ArrayList<int[]> processList = new ArrayList<int[]>();
		processList.add(new int[]{1,2,3});
		processList.add(new int[]{1,2,0}); // executable
		processList.add(new int[]{3,4,2});
		processList.add(new int[]{1,1,1}); // executable
		int index = pc.getExecutableIndex(processList);
		assertEquals(1, index);
	}
	
	@Test
	public void testExecutable2() {
		int[] curAvailRes = {5};
		ProcessCheckerImpl pc = new ProcessCheckerImpl(curAvailRes);
		ArrayList<int[]> processList = new ArrayList<int[]>();
		processList.add(new int[]{7});
		processList.add(new int[]{6});
		processList.add(new int[]{4}); // executable
		processList.add(new int[]{4}); // executable
		processList.add(new int[]{4}); // executable
		processList.add(new int[]{4}); // executable
		processList.add(new int[]{4}); // executable		
		int index = pc.getExecutableIndex(processList);
		assertEquals(2, index);
	}
	
	@Test
	public void testExecutable3() {
		int[] curAvailRes = {1,1,1,1,1,1,1,1,1,1,1};
		ProcessCheckerImpl pc = new ProcessCheckerImpl(curAvailRes);
		ArrayList<int[]> processList = new ArrayList<int[]>();
		processList.add(new int[]{1,2,1,1,1,1,1,1,1,1,1});
		processList.add(new int[]{1,1,1,1,4,1,1,1,1,1,1});
		processList.add(new int[]{1,1,1,1,1,1,1,1,1,5,1});
		processList.add(new int[]{1,1,1,1,1,1,1,1,1,1,1}); // executable
		int index = pc.getExecutableIndex(processList);
		assertEquals(3, index);
	}
	
	
	@Test
	public void testExecutable4() {
		int[] curAvailRes = {3,3,2,4};
		ProcessCheckerImpl pc = new ProcessCheckerImpl(curAvailRes);
		ArrayList<int[]> processList = new ArrayList<int[]>();
		processList.add(new int[]{3,2,1,0});  // executable
		processList.add(new int[]{3,2,1,0});  // executable
		processList.add(new int[]{3,2,1,0});  // executable
		processList.add(new int[]{3,2,1,0});  // executable
		processList.add(new int[]{3,2,1,0});  // executable
		int index = pc.getExecutableIndex(processList);
		assertEquals(0, index);
	}
	
	@Test
	public void testNotExecutable1() {
		int[] curAvailRes = {7,6,7,6};
		ProcessCheckerImpl pc = new ProcessCheckerImpl(curAvailRes);
		ArrayList<int[]> processList = new ArrayList<int[]>();
		processList.add(new int[]{8,1,1,1}); 
		processList.add(new int[]{1,8,8,8});
		processList.add(new int[]{1,1,1,8}); 
		processList.add(new int[]{6,7,6,7}); 
		processList.add(new int[]{10000,10000,1000,1000}); 
		int index = pc.getExecutableIndex(processList);
		assertEquals(-1, index);
	}	
	
	@Test
	public void testNotExecutable2() {
		int[] curAvailRes = {3,3,2,4};
		ProcessCheckerImpl pc = new ProcessCheckerImpl(curAvailRes);
		ArrayList<int[]> processList = new ArrayList<int[]>();
		processList.add(new int[]{100,2,1,0}); 
		processList.add(new int[]{100,1,1,1}); 
		processList.add(new int[]{100,2,1,0});  
		processList.add(new int[]{3,2,1,100}); 
		processList.add(new int[]{3,2,1,100});  
		int index = pc.getExecutableIndex(processList);
		assertEquals(-1, index);
	}	
	

}
