package de.unima.ki.pi2.ptest.aufgabe4.test;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import de.unima.ki.pi2.ptest.aufgabe4.api.FixPointZO;
import de.unima.ki.pi2.ptest.aufgabe4.impl.FixPointZOImpl;

public class FixPointZOTest {
	
	final private double DELTA = 0.000000001;
	
	FixPointZO fp;
	
	@Before
	public void init(){ 
		this.fp = new FixPointZOImpl();
	}

	@Test
	public void test1() {
		boolean[] v = {true, true};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(-0.5, dv, DELTA);
	}
	
	@Test
	public void test2() {
		boolean[] v = {false, true};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(0.5, dv, DELTA);
	}
	
	
	@Test
	public void test3() {
		boolean[] v = {false, false, true};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(0.25, dv, DELTA);
	}


	@Test
	public void test4() {
		boolean[] v = {false, false, false, true};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(0.125, dv, DELTA);
	}
	
	@Test
	public void test5() {
		boolean[] v = {true, true, true, true};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(-0.875, dv, DELTA);
	}
	
	@Test
	public void test6() {
		boolean[] v = {false, true, true, true, false, false, false, true, true, true};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(0.888671875, dv, DELTA);
	}
	
	@Test
	public void test7() {
		boolean[] v = {true, true, false, false, false, false, true};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(-0.515625, dv, DELTA);
	}
	
	@Test
	public void test01() {
		boolean[] v = {false};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(0, dv, DELTA);
	}
	
	@Test
	public void test02() {
		boolean[] v = {true};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(0, dv, DELTA);
	}
	
	
	@Test
	public void test03() {
		boolean[] v = {true, false, false, false};
		this.fp.setValue(v);
		double dv = this.fp.getDoubleValue();
		assertEquals(0, dv, DELTA);
	}
	
	
	
	
	

}
